<template>
	<a-drawer
		:title="formData.id ? '编辑期货信息' : '增加期货信息'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<template v-if="formData.id">
				<a-form-item label="代码：" name="futuresCode">
					<a-input v-model:value="formData.futuresCode" placeholder="请输入代码" disabled/>
				</a-form-item>
				<a-form-item label="名称：" name="futuresName">
					<a-input v-model:value="formData.futuresName" placeholder="请输入名称" allow-clear/>
				</a-form-item>
			</template>
			<template v-else>
				<a-form-item label="代码：" name="futuresCode">
					<a-input v-model:value="formData.futuresCode" placeholder="请输入代码" allow-clear/>
				</a-form-item>
				<a-form-item label="名称：" name="futuresName">
					<a-input v-model:value="formData.futuresName" placeholder="请输入名称" allow-clear/>
				</a-form-item>
			</template>
			<a-form-item label="价格(元)：" name="futuresPrice">
				<a-input-number v-model:value="formData.futuresPrice" :min="0.01" style="width:100%" placeholder="请输入价格" allow-clear/>
			</a-form-item>
			<a-form-item label="单位：" name="futuresUnit">
				<a-input v-model:value="formData.futuresUnit" placeholder="请输入单位" allow-clear/>
			</a-form-item>
			<a-form-item label="备注：" name="remark">
				<a-input v-model:value="formData.remark" placeholder="请输入备注" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotZoneFuturesForm">
import {cloneDeep} from 'lodash-es'
import {required, rules} from '@/utils/formRules'
import depotZoneFuturesApi from '@/api/biz/depotZoneFuturesApi'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	futuresName: [required('请输入')],
	futuresPrice: [required('请输入'), rules.amountCheck],
	futuresUnit: [required('请输入')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotZoneFuturesApi
				.depotZoneFuturesSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
